local l_gfx = love.graphics

Assets = {}
Assets.__index = Assets

function Assets:new()
	local self = setmetatable({},Assets)
	
	self.characters_atlas = l_gfx.newImage("gfx/chars.png")
	
	self.font = l_gfx.newFont("gfx/fonts/modeseven.ttf",22)
	self.font:setFilter("nearest","nearest")
	
	local chw,chh = self.characters_atlas:getDimensions()
	self.charquads = {
		zombie = {
			l_gfx.newQuad(96,0, 48,96, chw,chh),
			l_gfx.newQuad(144,0, 48,96, chw,chh),
			l_gfx.newQuad(192,0, 48,96, chw,chh),
		},
		zombie_atk = {
			l_gfx.newQuad(96,96, 48,96, chw,chh),
			l_gfx.newQuad(144,96, 48,96, chw,chh),
		
		},
		ghost = {
			l_gfx.newQuad(0,0, 32,64, chw,chh),
			l_gfx.newQuad(32,0, 32,64, chw,chh),
			l_gfx.newQuad(64,0, 32,64, chw,chh),
		},
		hpbar = {
			l_gfx.newQuad(0,64, 1,8, chw,chh),
			l_gfx.newQuad(1,64, 1,6, chw,chh)
		}
	}
	
	self.tile_atlas = l_gfx.newImage("gfx/grass03.png")
	self.tile_atlas:setFilter("nearest","nearest")
	local thw,thh = self.tile_atlas:getDimensions()
	self.tile_quads = {
		grass = {
			l_gfx.newQuad(0,0,512,512,thw,thh)
		}
	}
	
	self.ui_atlas = l_gfx.newImage("gfx/uispr.png")
	local usprw, usprh = self.ui_atlas:getDimensions()
	self.ui_quads = {
		health = l_gfx.newQuad(0,0,254,33,usprw, usprh),
		score = l_gfx.newQuad(0,40,254,33,usprw, usprh),
		lvlbar = l_gfx.newQuad(0,33,18,7,usprw, usprh),
	}
	
	self.ui_atlas:setFilter("nearest","nearest")
	self.characters_atlas:setFilter("nearest","nearest")
	return self
end