-- boxcaster helper by mkdxdx 2015
-- use it as u like, feedback is appretiated

BoxCaster = {}
BoxCaster.__index = BoxCaster
BoxCaster.ident = "c_boxcaster"
BoxCaster.ignoreSensors = true
BoxCaster.FilterModes = {None = 1, IgnoreIfListed = 2, IncludeIfListed = 3, IncludeOnlyListed = 4}
BoxCaster.filterMode = BoxCaster.FilterModes.None
function BoxCaster:new(world)
	local self = setmetatable({},BoxCaster)
	self.world = world
	self.fixturelist = {}
	self.bounds = {0,0,0,0}
	self.singleshot = false
	self.filterCategories = {}
	local ss = self.singleshot
	self.overlap = function(f)
		local add = false
		if self.filterMode == self.FilterModes.None or #self.filterCategories<= 0 then
			add = true
		elseif self.filterMode == self.FilterModes.IgnoreIfListed then
			local c1,c2 = f:getCategory()
			for i=1,#self.filterCategories do
				if self.filterCategories[i] == c1 or self.filterCategories[i] == c2 then
					add = false
					break
				end
			end
		elseif self.filterMode == self.FilterModes.IncludeIfListed then
			local c1,c2 = f:getCategory()
			for i=1,#self.filterCategories do
				if self.filterCategories[i] == c1 or self.filterCategories[i] == c2 then
					add = true
					break
				end
			end
		end
		if f:isSensor() == true and self.ignoreSensors == true then
			add = false
		end
		if add == true then
			self.fixturelist[#self.fixturelist+1] = f
		end
		return not(ss)
	end
	return self
end

function BoxCaster:setBounds(x0,y0,x1,y1)
	self.bounds[1] = x0 or self.bounds[1]
	self.bounds[2] = y0 or self.bounds[2]
	self.bounds[3] = x1 or self.bounds[3]
	self.bounds[4] = y1 or self.bounds[4]
end

function BoxCaster:setSingleshot(s)
	self.singleshot = s or self.singleshot
end

function BoxCaster:setIgnoreSensor(i)
	self.ignoreSensors = i
end

function BoxCaster:setFilterMode(fm)
	self.filterMode = fm or self.FilterModes.None
end

function BoxCaster:addFilterCategory(c)
	self.filterCategories[#self.filterCategories+1] = c
end

function BoxCaster:removeFilterCategory(c)
	if #self.filterCategories>0 then
		for i=1,#self.filterCategories,-1 do
			if self.filterCategories[i] == c then
				table.remove(self.filterCategories,i)
			end
		end
	end
end

function BoxCaster:test(x0,y0,x1,y1)
	self:clearFixtureList()
	local b = self.bounds
	self.world:queryBoundingBox(x0 or b[1], y0 or b[2], x1 or b[3], y1 or b[4],self.overlap)
	return self:getFixtureList()
end

function BoxCaster:clearFixtureList()
	local fl = self.fixturelist
	for k,v in pairs(fl) do
		fl[k] = nil
	end
end

function BoxCaster:getFixtureList()
	return self.fixturelist
end
