local l_gfx = love.graphics

Camera = {}
Camera.__index = Camera

function Camera:new()
	local self = setmetatable({},Camera)
	self.x = 0
	self.y = 0
	self.sx = 1
	self.sy = 1
	self.kx = 0
	self.ky = 0
	return self
end

function Camera:set()
	l_gfx.push()
	l_gfx.translate(-self.x,-self.y)
	l_gfx.scale(1/self.sx,1/self.sy)
	l_gfx.shear(self.kx,self.ky)
end

function Camera:unset()

	l_gfx.pop()
end

function Camera:setPosition(x,y)
	self.x,self.y = x,y
end

function Camera:setScale(sx,sy)
	self.sx,self.sy = sx,sy
end