Ghost = {}
Ghost.__index = Ghost
Ghost.ident = "entity_ghost"
Ghost.maxhealth = 120
Ghost.mul_fwd = 20
Ghost.mul_strf = 20
function Ghost:new()
	local self = setmetatable({},Ghost)
	self.sprites =  {
		StaticSprite:new(game.level.sb.entities,self.qlist[1])
	}
	
	self.anim = SpriteAnim:new(self.sprites[1],self.qlist)
	self.anim:setRate(2)
	self.m_fwd = 0
	self.m_strf= 0
	self.dir = 0
	self.health = self.maxhealth
	self.sprites[1]:setOffset(16,32)
	self:createBaseBody()
	self.fixture:setSensor(true)
	self.scanner = BoxCaster:new(game.level.physics)
	return self
end
setmetatable(Ghost,{__index = Entity})


function Ghost:mousepressed(x,y,b)
	if game.player.transfers > 0 then
		if b == 1 then
			if game.player.controls.ident == self.ident then
				local px,py = self:getPosition()
				local el = self.scanner:test(px-32,py-32,px+32,py+32)
				if #el> 0 then 
					self.m_fwd = 0
					self.m_strf = 0
					local t_e = el[math.random(#el)]:getUserData()
					game.player.controls = t_e
					t_e.marked = true
					game.player.transfers = game.player.transfers - 1
					game.player.level = 1
					t_e.anim.rate = 12
					self.sprites[1]:setScale(0,0)
				end
			end
		end
	end
end

function Ghost:update(dt)
	Entity.update(self,dt)
	if game.player.controls.id ~= self.id then
		self.sprites[1]:setScale(0,0)
	end
end
