local l_gfx = love.graphics
require("vaspritebatch")
Level = {}
Level.__index = Level

function Level:new()
	local self = setmetatable({},Level)
	--self.tiling = l_gfx.newSpriteBatch()
	self.sb = {
		entities = VASpriteBatch:new(Game.assets.characters_atlas,2000,"dynamic"),
		tiling = VASpriteBatch:new(Game.assets.tile_atlas,10000,"static")
	}
	self.sector_sz = 2048
	self.sectors = {}
	self.ids = 0
	self.entities = {}
	self.physics = love.physics.newWorld(0,0,true)
	return self
end

function Level:init()
	
end

function Level:update(dt)
	self.physics:update(dt)
	local plx,ply = game.player.controls:getPosition()
	local psx,psy = math.floor(plx/self.sector_sz),math.floor(ply/self.sector_sz)

	if self.sectors[psy] == nil then
		self.sectors[psy] = {}
	end
	if self.sectors[psy][psx] == nil then
		self.sectors[psy][psx] = 1
		for y=-2,5 do
			for x=-2,5 do
				self.sb.tiling:add(game.assets.tile_quads.grass[1],self.sector_sz*psx+x*512,self.sector_sz*psy+y*512,0,1,1)
			end
		end
	end
	
	
	local ec = #self.entities
	if ec>0 then
		for i=ec,1,-1 do
			self.entities[i]:update(dt)
			if self.entities[i].del == true then
				table.remove(self.entities,i)
			end
		end
	end
end

function Level:draw()
	for k,v in pairs(self.sb) do
		l_gfx.draw(v:getSpriteBatch())
	end
end

function Level:spawn(constructor)
	local e = constructor:new()
	e.id = self:getNewId()
	self.entities[#self.entities+1] = e
	return e
end

function Level:getNewId()
	self.ids = self.ids + 1
	return self.ids
end

require("entity")