
RayCaster = {}
RayCaster.__index = RayCaster
RayCaster.ident = "c_raycaster"
local fract_index = 6
RayCaster.raySortAscend = function(a,b) return a[fract_index]<b[fract_index] end
RayCaster.raySortDescend = function(a,b) return a[fract_index]>b[fract_index] end
RayCaster.ignoreSensors = true
function RayCaster:new(world)
	local self = setmetatable({},RayCaster)
	self.world = world
	self.hitlist = {}
	self.ignoreCategories = {}
	self.hit = function(f,x,y,nx,ny,fract)
		if self.ignoreSensors == true and f:isSensor() == true then 
			return 1
		else
			table.insert(self.hitlist,{f,x,y,nx,ny,fract})
		end
		return 1
	end
	return self
end

function RayCaster:cast(x0,y0,x1,y1)
	for k,v in pairs(self.hitlist) do
		self.hitlist[k] = nil
	end
	self.world:rayCast(x0,y0,x1,y1,self.hit)
	return self.hitlist
end

function RayCaster:getHitList()
	return self.hitlist
end

function RayCaster:sortAscend()
	table.sort(self.hitlist,RayCaster.raySortAscend)
end

function RayCaster:sortDescend()
	table.sort(self.hitlist,RayCaster.raySortDescend)
end

function RayCaster:setIgnoreSensors(i)
	self.ignoreSensors = i
end	