-- staticsprite helper by mkdxdx


StaticSprite = {}
StaticSprite.__index = StaticSprite
StaticSprite.x = 0
StaticSprite.y = 0
StaticSprite.r = 0
StaticSprite.sx = 1
StaticSprite.sy = 1
StaticSprite.ox = 0
StaticSprite.oy = 0
StaticSprite.kx = 0
StaticSprite.ky = 0
StaticSprite.ex = 0
StaticSprite.ey = 0
StaticSprite.bufferIncrement = 100
StaticSprite.useVertexAttributes = true
-- create SpriteCollection which will be augmented spritebatch with vertex attribute support (toggleable)
-- then create StaticSprite:ChangeVertexAttribute to change vertex attribute in the sprite collection

function StaticSprite:new(batch,q,tint,z)
	local self = setmetatable({},StaticSprite)
	if batch:getCount()>=batch:getBufferSize() then
		batch:setBufferSize(batch:getCount()+self.bufferIncrement)
	end
	self.batch = batch
	self.q = q
	self.id = batch:add(self.q,self.x,self.y,self.r,self.sx,self.sy,self.ox,self.oy,self.kx,self.ky)
	return self
end

function StaticSprite:set(q,x,y,r,sx,sy,ox,oy,kx,ky,ex,ey)
	self.q = q or self.q
	self.x = x or self.x
	self.y = y or self.y
	self.r = y or self.r
	self.sx = sx or self.sx
	self.sy = sy or self.sy
	self.ox = ox or self.ox
	self.oy = oy or self.oy
	self.kx = kx or self.kx
	self.ky = ky or self.ky
	self.ex = ex or self.ex
	self.ey = ey or self.ey
	self.batch:set(self.id,self.q,self.x+self.ex,self.y+self.ey,self.r,self.sx,self.sy,self.ox,self.oy,self.kx,self.ky)
end

function StaticSprite:setQuad(q)
	self.q = q or self.q
	self:set()
end

function StaticSprite:setPosition(x,y)
	self.x = x or self.x
	self.y = y or self.y
	self:set()
end

function StaticSprite:setScale(sx,sy)
	self.sx = sx or self.sx
	self.sy = sy or self.sy
	self:set()
end

function StaticSprite:setRotation(r)
	self.r = r or self.r
	self:set()
end

function StaticSprite:setOffset(ox,oy)
	self.ox = ox or self.ox
	self.oy = oy or self.oy
	self:set()
end

function StaticSprite:setEntityOffset(ex,ey)
	self.ex = ex or self.ex
	self.ey = ey or self.ey
end

function StaticSprite:getVertex(vert_index)
	return self.batch:getVertex((self.id-1)*4+vert_index)
end

function StaticSprite:setVertex(vert_index,x,y,u,v,r,g,b,a)
	self.batch:setVertex((self.id-1)*4+vert_index, x,y, u,v, r,g,b,a)
end

function StaticSprite:setColor(r,g,b,a)
	local cr,cg,cb,ca = self.batch:getColor()
	self.batch:setSpriteColor(self.id,r,g,b,a)
	self:set()
	self.batch:setColor(cr,cg,cb,ca)
end

function StaticSprite:release()
	self.batch:releaseSprite(self.id)
end

