SpriteAnim = {}
SpriteAnim.__index = SpriteAnim
SpriteAnim.rate = 1
SpriteAnim.loop = true
SpriteAnim.progress = true
function SpriteAnim:new(spr,quadset)
	local self = setmetatable({},SpriteAnim)
	self.index = 1
	self.t = 1
	self.quadset = quadset
	self.sprite = spr
	return self
end

function SpriteAnim:update(dt)
	if self:isPlaying() == true then
		self.t = self.t - dt*self.rate
		if self.t<=0 then 
			self.t = 1
			self.index = self.index + 1
			if self.index>#self.quadset then 
				if self.loop == true then
					self.index = 1
				else
					self.index = #self.quadset
					self:pause()
				end
			end
			self.sprite:setQuad(self.quadset[self.index])
		end
	end
end

function SpriteAnim:setQuadset(qset) self.quadset = qset self.index = 1 self.t = 1 self.sprite:setQuad(self.quadset[self.index]) end
function SpriteAnim:setRate(rate) self.rate = rate end
function SpriteAnim:start() self.index = 1 self.progress = true end
function SpriteAnim:stop() self.progress = false self.index = 1 end
function SpriteAnim:pause()	self.progress = false end
function SpriteAnim:resume() self.progress = true end
function SpriteAnim:isPlaying() return self.progress end
function SpriteAnim:getIndex() return self.index end